"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./components/index");
var react_1 = __importStar(require("react"));
var reactive_1 = require("./reactive");
var rxjs_1 = require("rxjs");
var stream_store_1 = require("./stream-store");
var utils_1 = require("./utils");
var getSelfAlias = function (links) {
    return Object.keys(links)
        .flatMap(function (rel) { return links[rel]; })
        .filter(function (_a) {
        var rel = _a.rel;
        return rel && rel.indexOf('streamStore:') === 0;
    })
        .filter(function (_a) {
        var href = _a.href;
        return !!links.self.filter(function (link) { return link.href === href; }).length;
    })
        .map(function (_a) {
        var rel = _a.rel;
        return rel;
    });
};
var self$ = stream_store_1.store.hal$.links$
    .filter(function (links) { return !!links.self; })
    .map(getSelfAlias)
    .filter(function (rel) { return !!rel; })
    .map(function (_a) {
    var _b = __read(_a, 1), link = _b[0];
    return link;
});
var state$ = reactive_1.createState(rxjs_1.Observable.merge(self$.map(function (self) { return ['self', function () { return self; }]; }), stream_store_1.store.hal$.links$.map(function (links) { return ['_links', function () { return links; }]; }), stream_store_1.store.hal$.forms$.map(function (forms) { return ['forms', function () { return forms; }]; }), stream_store_1.store.hal$.loading$.map(function (loading) { return ['loading', function () { return loading; }]; }), stream_store_1.store.mediaType$.map(function (mediaType) { return ['mediaType', function () { return mediaType; }]; })), rxjs_1.Observable.of({
    _links: {},
    forms: {},
    loading: false,
    mediaType: utils_1.mediaTypes.hal,
    self: {
        href: '',
    },
}));
var onNavigate = function (link, authorization) {
    link.href.indexOf('#') === -1 && stream_store_1.actions.get.request.next({ link: link, headers: { authorization: authorization } });
};
var EmbeddedSqlStreamStoreBrowser = index_1.withAuthorization()(function (_a) {
    var props = __rest(_a, []);
    react_1.useEffect(function () {
        onNavigate({ href: props.currentUrl, type: props.mediaType }, props.authorization);
        stream_store_1.location.subscribeToAction(props.onUrlChanged);
    }, []);
    return (react_1.default.createElement(index_1.NavigationProvider, { onNavigate: onNavigate },
        react_1.default.createElement(stream_store_1.Viewer, __assign({}, props)),
        react_1.default.createElement(index_1.Notifications, null)));
});
var AuthorizedSqlStreamStoreBrowser = function (_a) {
    var authorization = _a.authorization, props = __rest(_a, ["authorization"]);
    return (react_1.default.createElement(index_1.AuthorizationProvider, { authorization: authorization },
        react_1.default.createElement(EmbeddedSqlStreamStoreBrowser, __assign({}, props))));
};
exports.default = reactive_1.connect(state$)(AuthorizedSqlStreamStoreBrowser);
