"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var AuthorizationProvider_1 = require("./../../components/AuthorizationProvider");
var react_1 = __importStar(require("react"));
var react_schema_form_1 = require("react-schema-form");
var Dialog_1 = __importDefault(require("./Dialog"));
var TextAreaField_1 = __importDefault(require("./TextAreaField"));
var UuidField_1 = __importDefault(require("./UuidField"));
var mapper = {
    textarea: TextAreaField_1.default,
    uuid: UuidField_1.default,
};
var FormButton = /** @class */ (function (_super) {
    __extends(FormButton, _super);
    function FormButton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            model: {},
        };
        _this._onSubmit = function () {
            var _a = _this.props, rel = _a.rel, link = _a.link, actions = _a.actions, authorization = _a.authorization;
            var body = _this.state.model;
            if (actions[rel]) {
                actions[rel].request.next({
                    body: body,
                    headers: {
                        authorization: authorization,
                    },
                    link: link,
                });
            }
        };
        _this._onModelChange = function (key, value) {
            var _a;
            var _b = _this.state, model = _b.model, state = __rest(_b, ["model"]);
            _this.setState(__assign({}, state, { model: __assign({}, model, (_a = {}, _a[key] = value, _a)) }));
        };
        return _this;
    }
    FormButton.prototype.render = function () {
        var _a = this.props, schema = _a.schema, rel = _a.rel, curies = _a.curies;
        var model = this.state.model;
        return (react_1.default.createElement(Dialog_1.default, { rel: rel, title: schema.title, curies: curies, onSubmit: this._onSubmit },
            react_1.default.createElement(react_schema_form_1.SchemaForm, { schema: schema, model: model, mapper: mapper, onModelChange: this._onModelChange })));
    };
    return FormButton;
}(react_1.PureComponent));
exports.default = AuthorizationProvider_1.withAuthorization()(FormButton);
