"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importDefault(require("react"));
var react_schema_form_1 = require("react-schema-form");
var getDisplayValue = function (value) {
    return typeof value === 'string' ? value : JSON.stringify(value);
};
var TextAreaField = /** @class */ (function (_super) {
    __extends(TextAreaField, _super);
    function TextAreaField(props) {
        var _this = _super.call(this, props) || this;
        _this._onChangeValidate = function (e, v) {
            var _a = _this.props, form = _a.form, onChangeValidate = _a.onChangeValidate;
            var tryParseJson = function (value) {
                if (!value) {
                    return undefined;
                }
                try {
                    return JSON.parse(value);
                }
                catch (e) {
                    return value;
                }
            };
            onChangeValidate(__assign({}, e, { currentTarget: __assign({}, e.currentTarget, { 
                    // @ts-ignore
                    value: form.schema.type === 'object'
                        ? tryParseJson(e.target.value)
                        : e.target.value }), target: {
                    // @ts-ignore
                    value: form.schema.type === 'object'
                        ? tryParseJson(e.target.value)
                        : e.target.value,
                } }), v);
        };
        return _this;
    }
    TextAreaField.prototype.render = function () {
        var _a = this.props, form = _a.form, error = _a.error, value = _a.value;
        return (react_1.default.createElement("div", { className: form.htmlClass },
            react_1.default.createElement(core_1.TextField, { type: form.type, label: form.title, placeholder: form.placeholder, helperText: error || form.description, error: !!error, onChange: this._onChangeValidate, value: getDisplayValue(value), disabled: form.readonly, fullWidth: true, multiline: true, rows: 15, rowsMax: 15 })));
    };
    return TextAreaField;
}(react_1.default.PureComponent));
exports.default = react_schema_form_1.ComposedComponent(TextAreaField);
