"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importDefault(require("react"));
var reactive_1 = require("./../../reactive");
var rxjs_1 = require("rxjs");
var stream_store_1 = require("./../../stream-store");
var FormButton_1 = __importDefault(require("./FormButton"));
var LinkButton_1 = __importDefault(require("./LinkButton"));
var isNotSelf = function (rel, links) {
    return links[stream_store_1.rels.self] && links[rel][0].href !== links[stream_store_1.rels.self][0].href;
};
var state$ = reactive_1.createState(stream_store_1.store.hal$.url$.map(function (href) { return ['href', function () { return href; }]; }), rxjs_1.Observable.of({ href: '' }));
var HyperMediaControls = function (_a) {
    var actions = _a.actions, forms = _a.forms, href = _a.href, _links = _a._links;
    return (react_1.default.createElement(core_1.Card, null,
        react_1.default.createElement(core_1.CardActions, null,
            react_1.default.createElement("div", null,
                Object.keys(_links)
                    .filter(function (rel) { return !stream_store_1.navigation.has(rel); })
                    .filter(function (rel) { return isNotSelf(rel, _links); })
                    .map(function (rel) { return (react_1.default.createElement(LinkButton_1.default, { key: rel, rel: rel, link: _links[rel][0], color: 'primary', curies: _links[stream_store_1.rels.curies] })); }),
                Object.keys(forms).map(function (rel) { return (react_1.default.createElement(FormButton_1.default, { key: rel, rel: rel, link: { href: href }, actions: actions, schema: forms[rel], curies: _links[stream_store_1.rels.curies] })); })))));
};
exports.default = reactive_1.connect(state$)(HyperMediaControls);
