"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var getDisplayName_1 = __importDefault(require("./getDisplayName"));
var defaultNavigationHandler = function (link, authorization) {
    return;
};
var _a = react_1.default.createContext(defaultNavigationHandler), Consumer = _a.Consumer, Provider = _a.Provider;
var NavigationProvider = function (_a) {
    var onNavigate = _a.onNavigate, children = _a.children;
    return (react_1.default.createElement(Provider, { value: onNavigate }, children));
};
exports.default = NavigationProvider;
var withNavigation = function () { return function (WrappedComponent) {
    var Component = function (props) { return (react_1.default.createElement(Consumer, null, function (onNavigate) { return (react_1.default.createElement(WrappedComponent, __assign({}, props, { onNavigate: onNavigate }))); })); };
    Component.displayName = getDisplayName_1.default('WithNavigation', WrappedComponent);
    return Component;
}; };
exports.withNavigation = withNavigation;
