"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var colors_1 = require("@material-ui/core/colors");
var classnames_1 = __importDefault(require("classnames"));
var icons_1 = require("./../icons");
var react_1 = __importStar(require("react"));
var reactive_1 = require("./../reactive");
var rxjs_1 = require("rxjs");
var stream_store_1 = require("./../stream-store");
var uuid_1 = __importDefault(require("uuid"));
var iconsByVariant = {
    error: icons_1.Error,
    info: icons_1.Info,
    success: icons_1.CheckCircle,
    warning: icons_1.Warning,
};
var formatTitle = function (_a) {
    var status = _a.status, statusText = _a.statusText;
    return status + " " + statusText;
};
var formatSubheader = function (_a) {
    var title = _a.title, type = _a.type;
    return title ? title + " (" + type + ")" : undefined;
};
var formatContent = function (_a) {
    var detail = _a.detail;
    return !!detail
        ? detail
            .split(/\r|\n/)
            .filter(function (x) { return x.length; })
            .reduce(function (akk, line, index) { return __spread(akk, [
            react_1.default.createElement("br", { key: index * 2 }),
            react_1.default.createElement("span", { key: index * 2 + 1 }, line),
        ]); }, [])
        : [];
};
var verbs = Object.keys(stream_store_1.actions);
var responses$ = rxjs_1.Observable.merge.apply(rxjs_1.Observable, __spread(verbs.map(function (verb) { return stream_store_1.actions[verb].response; })));
var clientError$ = responses$
    .filter(function (_a) {
    var status = _a.status;
    return status >= 400 && status < 500;
})
    .map(function (_a) {
    var body = _a.body, response = __rest(_a, ["body"]);
    return ({
        content: formatContent(body),
        subheader: formatSubheader(body),
        title: formatTitle(response),
        variant: 'warning',
    });
});
var serverError$ = responses$
    .filter(function (_a) {
    var status = _a.status;
    return status >= 500;
})
    .map(function (_a) {
    var body = _a.body, response = __rest(_a, ["body"]);
    return ({
        content: formatContent(body),
        subheader: formatSubheader(body),
        title: formatTitle(response),
        variant: 'error',
    });
});
var unsafe = verbs
    .filter(function (verb) { return verb !== 'get'; })
    .map(function (verb) { return stream_store_1.actions[verb].response; });
var success$ = rxjs_1.Observable
    .merge.apply(rxjs_1.Observable, __spread(unsafe)).filter(function (_a) {
    var status = _a.status;
    return status < 400;
})
    .map(function (response) { return ({
    autoHideDuration: 2000,
    title: formatTitle(response),
    variant: 'success',
}); });
var dismiss = reactive_1.createAction();
var notification$ = rxjs_1.Observable
    .merge(clientError$, serverError$, success$)
    .map(function (notification) { return (__assign({}, notification, { messageId: uuid_1.default.v4() })); });
var state$ = reactive_1.createState(rxjs_1.Observable.merge(notification$.map(function (notification) { return [
    'notifications',
    function (notifications) { return __spread(notifications, [
        notification,
    ]); },
]; }), dismiss.map(function (messageId) { return [
    'notifications',
    function (notifications) {
        return notifications.filter(function (n) { return n.messageId !== messageId; });
    },
]; })), rxjs_1.Observable.of({
    notifications: [],
}));
var styles = function (theme) { return ({
    error: {
        backgroundColor: colors_1.red[500],
    },
    icon: {
        fontSize: 20,
    },
    iconVariant: {
        marginRight: theme.spacing.unit,
        opacity: 0.9,
    },
    info: {
        backgroundColor: colors_1.blue[500],
    },
    message: {
        alignItems: 'center',
        display: 'flex',
    },
    success: {
        backgroundColor: colors_1.green[600],
    },
    warning: {
        backgroundColor: colors_1.amber[700],
    },
}); };
var Notification = core_1.withStyles(styles)(function (_a) {
    var autoHideDuration = _a.autoHideDuration, className = _a.className, classes = _a.classes, content = _a.content, messageId = _a.messageId, subheader = _a.subheader, title = _a.title, variant = _a.variant, other = __rest(_a, ["autoHideDuration", "className", "classes", "content", "messageId", "subheader", "title", "variant"]);
    return (react_1.default.createElement(core_1.Snackbar, { open: true, anchorOrigin: {
            horizontal: 'right',
            vertical: 'bottom',
        }, autoHideDuration: autoHideDuration },
        react_1.default.createElement(core_1.SnackbarContent, __assign({ className: classnames_1.default(classes[variant], className), message: react_1.default.createElement("span", { className: classes.message },
                react_1.default.createElement(core_1.Typography, { variant: 'body2' },
                    react_1.createElement(iconsByVariant[variant], {
                        className: classnames_1.default(classes.icon, classes.iconVariant),
                    }),
                    title,
                    " ",
                    subheader,
                    react_1.default.createElement("br", null),
                    content)), action: [
                react_1.default.createElement(core_1.IconButton, { key: 'close', color: 'inherit', onClick: function () { return dismiss.next(messageId); } },
                    react_1.default.createElement(core_1.Typography, { variant: 'body2' },
                        react_1.default.createElement(icons_1.Close, { className: classes.icon }))),
            ] }, other))));
});
var Notifications = function (_a) {
    var _b = _a.notifications, notifications = _b === void 0 ? [] : _b;
    return (react_1.default.createElement("div", null, notifications.map(function (notification) { return (react_1.default.createElement(Notification, __assign({ key: notification.messageId }, notification))); })));
};
exports.default = reactive_1.connect(state$)(Notifications);
