"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importDefault(require("react"));
var stream_store_1 = require("./../stream-store");
var Hyperlink_1 = __importDefault(require("./Hyperlink"));
var styles = function (theme) { return ({
    browser: {
        padding: theme.spacing.unit * 2.5,
    },
}); };
var StreamBrowser = core_1.withStyles(styles)(function (_a) {
    var streams = _a.streams, classes = _a.classes, loading = _a.loading;
    return (react_1.default.createElement("div", { className: classes.browser },
        react_1.default.createElement(core_1.Typography, { variant: 'title' }, "Stream Browser"),
        loading ? (react_1.default.createElement(core_1.LinearProgress, null)) : streams.length ? (react_1.default.createElement(core_1.List, null, streams.map(function (_a) {
            var _links = _a._links;
            return (react_1.default.createElement(core_1.ListItem, { key: _links[stream_store_1.rels.self].map(function (_a) {
                    var href = _a.href;
                    return href;
                })[0] },
                react_1.default.createElement(core_1.ListItemText, null,
                    react_1.default.createElement(Hyperlink_1.default, { _links: _links, rel: stream_store_1.rels.feed }))));
        }))) : (react_1.default.createElement(core_1.Typography, { variant: 'body2' }, "No matching streams found."))));
});
exports.default = StreamBrowser;
