"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var components_1 = require("./../../../components");
var react_1 = __importDefault(require("react"));
var reactive_1 = require("./../../../reactive");
var rxjs_1 = require("rxjs");
var rels_1 = __importDefault(require("./../../../stream-store/rels"));
var store_1 = __importDefault(require("./../../../stream-store/store"));
var components_2 = require("./components");
var metadata$ = store_1.default.hal$.body$.map(function (metadata) { return metadata; });
var state$ = reactive_1.createState(metadata$.map(function (metadata) { return ['metadata', function () { return metadata; }]; }), rxjs_1.Observable.of({
    metadata: {
        _embedded: {},
        _links: {},
        streamId: '',
    },
}));
var nowrap = { whiteSpace: 'nowrap' };
var StreamMetadataHeader = function () { return (react_1.default.createElement(components_1.Table.Row, null,
    react_1.default.createElement(components_1.Table.Cell, null, 'Stream'),
    react_1.default.createElement(components_1.Table.Cell, null, 'Max Age'),
    react_1.default.createElement(components_1.Table.Cell, null, 'Max Count'))); };
var StreamMetadataDetails = function (_a) {
    var streamId = _a.streamId, maxAge = _a.maxAge, maxCount = _a.maxCount, _links = _a._links;
    return (react_1.default.createElement(components_1.Table.Row, null,
        react_1.default.createElement(components_1.Table.Cell, { style: nowrap },
            react_1.default.createElement(components_1.Hyperlink, { _links: _links, rel: rels_1.default.feed })),
        react_1.default.createElement(components_1.Table.Cell, { style: nowrap, numeric: true }, maxAge),
        react_1.default.createElement(components_1.Table.Cell, { style: nowrap, numeric: true }, maxCount)));
};
var StreamMetadata = function (_a) {
    var metadata = _a.metadata;
    return (react_1.default.createElement("section", null,
        react_1.default.createElement(components_1.Table, { style: { tableLayout: 'auto' } },
            react_1.default.createElement(components_1.Table.Head, null,
                react_1.default.createElement(StreamMetadataHeader, null)),
            react_1.default.createElement(components_1.Table.Body, null,
                react_1.default.createElement(StreamMetadataDetails, __assign({}, metadata)))),
        react_1.default.createElement(components_2.JsonViewer, { json: metadata.metadataJson })));
};
exports.default = reactive_1.connect(state$)(StreamMetadata);
