"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var components_1 = require("./../../../components");
var react_1 = __importDefault(require("react"));
var react_json_view_1 = __importDefault(require("react-json-view"));
var reactive_1 = require("./../../../reactive");
var rxjs_1 = require("rxjs");
var store_1 = __importDefault(require("./../../../stream-store/store"));
var themes_1 = __importDefault(require("../../../themes"));
var utils_1 = require("./../../../utils");
var isHyperlink = function (name, namespace) {
    return name === 'href' && namespace.filter(function (n) { return n === '_links'; }).length > 0;
};
var state$ = reactive_1.createState(rxjs_1.Observable.merge(store_1.default.hal$.body$.map(function (src) { return ['src', function () { return src; }]; }), themes_1.default.theme$.map(function (_a) {
    var type = _a.palette.type;
    return [
        'theme',
        function () { return utils_1.reactJsonTheme(type); },
    ];
})), rxjs_1.Observable.of({
    src: {},
    theme: utils_1.reactJsonTheme(),
}));
var UnrecognizedRelViewer = components_1.withNavigation()(/** @class */ (function (_super) {
    __extends(class_1, _super);
    function class_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._handlePotentialNavigation = function (_a) {
            var name = _a.name, value = _a.value, namespace = _a.namespace;
            var _b = _this.props, authorization = _b.authorization, onNavigate = _b.onNavigate;
            if (!isHyperlink(name, namespace)) {
                return;
            }
            onNavigate({
                href: value,
            }, authorization);
        };
        return _this;
    }
    class_1.prototype.render = function () {
        return (react_1.default.createElement(react_json_view_1.default, __assign({}, this.props, { onSelect: this._handlePotentialNavigation })));
    };
    return class_1;
}(react_1.default.PureComponent)));
exports.default = reactive_1.connect(state$)(UnrecognizedRelViewer);
