"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var reactive_1 = require("./../reactive");
var utils_1 = require("./../utils");
var verbs = Object.keys(utils_1.http);
var actions = verbs.reduce(function (akk, verb) {
    var _a;
    return (__assign({}, akk, (_a = {}, _a[verb] = {
        request: reactive_1.createAction(),
        response: reactive_1.createAction(),
    }, _a)));
}, 
// tslint:disable-next-line:no-object-literal-type-assertion
{});
verbs.forEach(function (verb) {
    return actions[verb].request
        .flatMap(function (request) { return utils_1.http[verb](request); })
        .subscribe(function (response) { return actions[verb].response.next(response); });
});
exports.default = actions;
