"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var reactive_1 = require("./../../../reactive");
var rxjs_1 = require("rxjs");
var rels_1 = __importDefault(require("./../../../stream-store/rels"));
var uri_template_1 = __importDefault(require("uri-template"));
var links_1 = __importDefault(require("./links"));
var isPotentialStreamId = function (data) {
    return typeof data === 'number' || typeof data === 'string';
};
var clickPotentialStreamId = reactive_1.createAction().filter(isPotentialStreamId);
var pattern$ = rxjs_1.Observable.merge(clickPotentialStreamId.map(function (pattern) { return pattern; }), clickPotentialStreamId.map(function (pattern) { return String(pattern).replace(/-/g, ''); })).distinct();
var template$ = links_1.default
    .filter(function (links) { return !!links[rels_1.default.browse]; })
    .map(function (links) { return links[rels_1.default.browse][0]; })
    .map(function (link) { return uri_template_1.default.parse(decodeURI(link.href)); });
pattern$.combineLatest(template$, function (p, template) { return ({
    headers: { authorization: '' },
    link: {
        href: template.expand({ p: p, t: 'e' }),
    },
}); });
