"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var rxjs_1 = require("rxjs");
var reactive_1 = require("./reactive");
var palette = function (type) { return ({
    action: {
        active: '#42c0fb',
    },
    type: type,
}); };
var typography = {
    useNextVariants: true,
};
var createTheme = function (type) {
    return core_1.createMuiTheme({
        palette: palette(type),
        typography: typography,
    });
};
var actions = {
    type: reactive_1.createAction(),
};
var paletteTypeKey = 'paletteType';
var loadPaletteType = function () {
    var type = window.localStorage.getItem(paletteTypeKey);
    return type === 'dark' ? 'dark' : 'light';
};
var savePaletteType = function (type) {
    return window.localStorage.setItem(paletteTypeKey, type);
};
var defaultTheme = createTheme(loadPaletteType());
var theme$ = reactive_1.createState(actions.type.map(function () { return [
    'theme',
    function (_a) {
        var type = _a.palette.type;
        return createTheme(type === 'light' ? 'dark' : 'light');
    },
]; }), rxjs_1.Observable.of({
    theme: defaultTheme,
})).map(function (_a) {
    var theme = _a.theme;
    return theme;
});
theme$.subscribe(function (_a) {
    var type = _a.palette.type;
    return savePaletteType(type);
});
exports.default = {
    actions: actions,
    defaultTheme: defaultTheme,
    theme$: theme$,
};
