import actions from "./actions";
import { history } from './../utils';
import { Action, Location } from 'history';


const location = {
    subscribeToDefault: () => {
        actions.get.response.subscribe(({ url }) => history.push(url));

        const getUrl = (location: Location) =>
            `${location.pathname}${location.search}${location.hash}`;

        history.listen(
            (location: Location, action: Action): void => {

                if (action !== 'POP') {
                    return;
                }
                actions.get.request.next({
                    headers: {},
                    link: { href: getUrl(location) },
                });
            },
        );
    },

    subscribeToAction: (action: (url: string) => void) => {
        actions.get.response.subscribe(({ url }) => action(url));
    }
}

export default location